(function() {
	$(".ultima-reports-generic-sqlchoice").each(function() {
		var input = $(this).find("input");
		var textarea = $(this).find("textarea");
		var multipleChoice = input.attr("data-multipleChoice").toLowerCase() === "true";

		var text = textarea.val();
		var options = text.split("__;;__").filter(function(part) {
		    return part != "";
		}).map(function(part) {
			var p = part.indexOf(":");
			var id = part.substring(0, p);
			var name = part.substring(p + 1);
			return {
				value: id,
				text: name
			};
		});

		input.selectize({
			maxItems: multipleChoice ? undefined : 1,
			delimiter: ',',
			sortField: [{
				field: "text",
				direction: "asc"
			}],
			plugins: [ "remove_button" ]
		});
		var selectize = input[0].selectize;
		selectize.load(function(callback) {
			callback(options);
		});

		// handle preset restoration
		var lastValue = null;
		input.on("change", function() {
			var currentValue = input.val();
			if (lastValue != currentValue) { // 'silent' tag in selectize.setValue() doesn't work
				lastValue = currentValue;
				var items = input.val().split(",");
				selectize.setValue(items, true);
			}
		});
	});

	$(".ultima-reports-generic-origin").each(function() {
		$(this).val(window.location.origin);
	});

	$(".ultima-reports-generic-timezone").each(function() {
        $(this).val(moment.tz.guess());
    });
}());