package extensions.reports.generic

import extensions.reports.JasperFormField
import net.sf.jasperreports.engine.JRParameter

abstract class AbstractJasperFormField extends JasperFormField {
  protected var keyValue: String = null

  protected var titleValue: String = null

  protected var defaultValue: String = null

  override def key(): String = keyValue

  override def title(): String = titleValue

  override def init(jrParameter: JRParameter): Unit = {
    keyValue = jrParameter.getName
    titleValue = jrParameter.getDescription
    defaultValue = Option(jrParameter.getDefaultValueExpression).map(_.getText).getOrElse("")
  }

  protected def getParameterProperty(jrParameter: JRParameter, key: String): Option[String] = {
    Option(jrParameter.getPropertiesMap).flatMap(m => Option(m.getProperty(key)))
  }
}
