package extensions.reports.generic

import com.typesafe.config.{ConfigObject, Config}
import extensions.reports.GenericFormField
import net.sf.jasperreports.engine.JRParameter
import play.twirl.api.Html
import utils.reports.FieldProperties

import scala.util.Try

class InputFormField() extends AbstractJasperFormField {

  private var inputType: String = null

  def this(key: String,
           title: String,
           fieldType: String,
           defaultValue: String) = {
    this()
    keyValue = key
    titleValue = title
    this.inputType = fieldType
    this.defaultValue = defaultValue
  }

  override def init(jrParameter: JRParameter): Unit = {
    super.init(jrParameter)

    inputType = Option(jrParameter.getPropertiesMap)
      .map(_.getProperty(FieldProperties.INPUT_TYPE))
      .getOrElse("text")
  }

  override def render(): Html = {
    views.html.reports.generic.input(key(), inputType, defaultValue)
  }

  override def parse(value: String): AnyRef = {
    if (inputType == "number") {
      if ("" == value) {
        new Integer(0)
      } else {
        Integer.valueOf(value)
      }
    } else {
      value
    }
  }
}