package extensions.reports.generic

import net.sf.jasperreports.engine.JRParameter
import play.twirl.api.Html
import utils.reports.FieldProperties

class PassFormField() extends AbstractJasperFormField {

  private var isMultiple: Boolean = false

  private var skipDeleted: Boolean = false

  def this(jrParameter: JRParameter, multiple: Boolean) = {
    this()
    this.keyValue = jrParameter.getName
    this.titleValue = jrParameter.getDescription
    this.isMultiple = multiple
  }

  override def init(jrParameter: JRParameter): Unit = {
    super.init(jrParameter)
    isMultiple = getParameterProperty(jrParameter, FieldProperties.MULTIPLE).map(_.toBoolean).getOrElse(false)
    skipDeleted = getParameterProperty(jrParameter, FieldProperties.SKIP_DELETED).map(_.toBoolean).getOrElse(false)
  }

  override def render(): Html = {
    views.html.reports.generic.pass(key(), isMultiple, skipDeleted)
  }

  override def parse(value: String): AnyRef = {
    value
  }
}
