package models.reports.generic

import scala.collection.mutable.ListBuffer

case class SQLChoiceOption(id: Long, name: String) {}

class SQLChoiceOptionComponent {
  def query(sqlQuery: String)(implicit connection: java.sql.Connection): Iterable[SQLChoiceOption] = {
    val statement = connection.createStatement()
    val resultSet = statement.executeQuery(sqlQuery)

    val resultListBuffer = ListBuffer[SQLChoiceOption]()

    while (resultSet.next()) {
      val id = resultSet.getInt("id")
      val name = resultSet.getString("name")
      resultListBuffer += SQLChoiceOption(id, name)
    }

    resultListBuffer.toSeq
  }
}
